/*
 * PointOfInterest.java
 *
 * AUTO_COPY_RIGHT_SUB_TAG
 */
package com.rim.samples.device.unifiedsearchdemo;

/**
 * Encapsulates information related to points of interest. Used primarily to
 * provide searchable information without having to obtain it from other sources.
 */
public class PointOfInterest 
{
    private String _name;
    private String _address;        
    
    /**
     * Creates a new PointOfInterest object
     * @param name Name of the point of interest
     * @param address Address of the point of interest     
     */
    public PointOfInterest(String name, String address)
    {
        _name = name;
        _address = address;        
    }
	
    public String toString()
    {
        return _name+", "+_address;
    }
	
    public String getName()
    {
        return _name;
    }

    public String getAddress()
    {
        return _address;
    }        
}
