/*
 * PointOfInterestPublisher.java
 *
 * AUTO_COPY_RIGHT_SUB_TAG
 */

package com.rim.samples.device.unifiedsearchdemo;

import java.util.Vector;

import net.rim.device.api.ui.component.*;
import net.rim.device.api.unifiedsearch.content.*;
import net.rim.device.api.unifiedsearch.registry.*;
import net.rim.device.api.unifiedsearch.entity.*;
import net.rim.device.api.ui.*;

/**
 * This class registers a PointOfInterstSearchable with the Unified Search
 * Framework and inserts POIs in the cache into the Unified Search Framework.
 */
public class PointOfInterestPublisher implements AppContentListener
{
    private PointOfInterestSearchable _pointOfInterestSearchable;    
    private RegistrationToken _regToken;  
    // private UiApplication _uiApplication; 
    
    public PointOfInterestPublisher() throws Exception
    {
        _pointOfInterestSearchable = new PointOfInterestSearchable();
        _regToken = SearchRegistry.getInstance().register(_pointOfInterestSearchable);

        if(!_regToken.isValid())                
        {
            throw new Exception("Application has failed to register with the Unified Search Framework");            
        }
    }    

    public void insertPOIs(Vector poiVector)
    {   
        PointOfInterestEntity[] poiEntities;
        synchronized(poiVector)
        {
            int size = poiVector.size();
            poiEntities = new PointOfInterestEntity[size];
            
            for(int i = size -1; i >= 0; --i)
            {
                PointOfInterest poi = (PointOfInterest) poiVector.elementAt(i);
                poiEntities[i] = new PointOfInterestEntity(poi, _pointOfInterestSearchable);
            }
        }
		_pointOfInterestSearchable.searchArray = poiEntities;
        AppContentManager.getInstance().insertContent(poiEntities,this,_regToken);        
        
        // _uiApplication = UiApplication.getUiApplication();
    }

    public void onInsertComplete(final int insertCount)
    {        
        // _uiApplication.invokeLater(new Runnable()
        // {
            // public void run()
            // {
                // Status.show("Inserted "+insertCount+" points of interest", 1250);
            // }
        // });
    }
	
    public void onUpdateComplete(int updCount){}
    public void onDeleteComplete(int delCount){}
}