/*
 * PointOfInterestSearchable.java
 *
 * AUTO_COPY_RIGHT_SUB_TAG
 */

package com.rim.samples.device.unifiedsearchdemo;

import net.rim.device.api.ui.image.*;
import net.rim.device.api.util.*;
import net.rim.device.api.system.*;
import net.rim.device.api.unifiedsearch.*;
import net.rim.device.api.unifiedsearch.entity.*;
import net.rim.device.api.unifiedsearch.query.*;
import net.rim.device.api.unifiedsearch.searchables.*;
import net.rim.device.api.unifiedsearch.action.*;

/**
 * Implementation of EntityBasedSearchable.  Allows application to provide
 * searchable content to the Unified Search Framework.
 */
public class PointOfInterestSearchable implements EntityBasedSearchable
{
    private long _registrationId;    
    private Image _icon;   
    private SearchField[] _searchFields;
	protected static SearchableEntity[] searchArray;

    public PointOfInterestSearchable()
    {
        _searchFields = new SearchField[] {new SearchField("Pizza")};
		
       _icon = ImageFactory.createImage(Bitmap.getBitmapResource("pizza.png"));
    }   

    public SearchableEntity[] getSearchableEntities()
    {
        return searchArray;
    }
 
    public SearchField[] defineSupportedSearchFields()
    {
        return _searchFields;
    }

    public Comparator getComparator()
    {
        return null;
    }

    public Image getIcon()
    {
        return _icon;
    }
	
    public String getName()
    {
        return "Unified Search Demo Publisher";
    }

    public int getPriority()
    {        
        return PRIORITY_NORMAL;
    }

    public int getPrivacyLevel()
    {        
        return ExposureLevel.LEVEL_PUBLIC;
    }

    public long getRegistrationID()
    {        
        return _registrationId;
    }

    public long getType()
    {        
        return (1l|SearchableContentTypeConstants.CONTENT_TYPE_LOCATION);         
    }  

    public void load(NotificationListener observer, int loadType)
	{
		observer.completed(this,NotificationListener.TYPE_SEARCHABLE);
	}

    public void pause(){}

    public void resume(){}

    public void setRegistrationID(long registrationId)
    {
        _registrationId = registrationId;
    }

    public UiAction[] getUiAction(SearchableEntity[] entities)
    {
        return null;
    }

    public UiAction getUiActions(SearchableEntity[] entities, Object contextObject, UiAction[] uiActions)
    {
        return null;
    }
}
