/*
 * UnifiedSearchDemo.java
 *
 * AUTO_COPY_RIGHT_SUB_TAG
 */

package com.rim.samples.device.unifiedsearchdemo;

import net.rim.device.api.ui.*;
import net.rim.device.api.ui.component.*;
import java.io.*;
import java.util.*;
import net.rim.device.api.ui.container.MainScreen;

/**
 * A sample application demonstrating how to publish and search for searchable
 * content using the Unified Search Framework.  This application implements
 * EntityBasedSearchable in the PointOfInterestSearchable class which allows
 * the application to publish content to the Unified Search Framework using
 * AppContentManager. 
 * 
 * The main UI screen for this application provides controls which add
 * PointOfInterest objects to the application and PointOfInterestEntity
 * objects encapsulating the POIs to the Unified Search Framework. An
 * additional screen allows a user to type keywords into an input field
 * while search results from the Unified Search Framework are displayed.
 */
public class UnifiedSearchDemo extends UiApplication
{

    public static void main(String[] args)
    {
        // Create a new instance of the application and make the currently running thread the application's event dispatch thread.
        UnifiedSearchDemo app = new UnifiedSearchDemo();
        app.enterEventDispatcher();
    }

    public UnifiedSearchDemo()
    {         
        try
        {
            PointOfInterestPublisher poiPublisher = new PointOfInterestPublisher();
            
			MainScreen s = new MainScreen();
			
			Vector _poiVector = new Vector();
			_poiVector.addElement(new PointOfInterest("Chicago Pizza", "600 Walkers Blvd"));
			_poiVector.addElement(new PointOfInterest("Ultimate Pizza", "471 Queen St"));
			_poiVector.addElement(new PointOfInterest("Pizza Slice", "200 Montreal Rd"));
			
			poiPublisher.insertPOIs(_poiVector);
			
			pushScreen(s);                    
        }
        catch(final Exception pe)
        {
            UiApplication.getUiApplication().invokeLater(new Runnable()
            {
                public void run()
                {
                    Dialog.alert(pe.toString());
                    System.exit(0);            
                } 
            }); 
        }        
    }    

    public static void errorDialog(final String message)
    {
        UiApplication.getUiApplication().invokeLater(new Runnable()
        {
            public void run()
            {
                Dialog.alert(message);
            } 
        });
    }
}
